
;MessageBox Control ID Test - DednDave - 8,2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;--------------------------------------------------------------------------------------------

CBTProc PROTO   :UINT,:WPARAM,:LPARAM

;--------------------------------------------------------------------------------------------

        .DATA

szTest     db 'Test',0
ReportFlag db 0

;---------------------------------------

        .DATA?

hMbHook    dd ?
szBuff     db 256 dup(?)

;--------------------------------------------------------------------------------------------

        .CODE

_main   PROC

        INVOKE  GetCurrentThreadId
        INVOKE  SetWindowsHookEx,WH_CBT,CBTProc,0,eax
        mov     hMbHook,eax
        INVOKE  MessageBox,0,offset szTest,offset szTest,MB_CANCELTRYCONTINUE or MB_HELP or MB_ICONINFORMATION
        INVOKE  UnhookWindowsHookEx,hMbHook
        exit

_main   ENDP

;--------------------------------------------------------------------------------------------

CBTProc PROC    nCode:UINT,wParam:WPARAM,lParam:LPARAM

        cmp dword ptr nCode,HCBT_ACTIVATE
        jnz     CbtP02

        cmp byte ptr ReportFlag,0
        jnz     CbtP02

        push    edi
        push    esi
        push    ebx
        mov     esi,1

loop00: INVOKE  GetDlgItem,wParam,esi
        or      eax,eax
        jz      loop01

        xchg    eax,ebx

        print   chr$(13,10,'Control ID: ')
        print   right$(uhex$(esi),4),44,32
        INVOKE  GetClassName,ebx,offset szBuff,sizeof szBuff-1
        print   offset szBuff
        print   chr$(13,10,'     Style: ')
        INVOKE  GetWindowLong,ebx,GWL_STYLE
        print   uhex$(eax),13,10
        print   chr$(' Ext Style: ')
        INVOKE  GetWindowLong,ebx,GWL_EXSTYLE
        print   uhex$(eax),13,10
        print   chr$('  Position: ')
        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,ebx,esp
        lea     eax,[esp+8]
        INVOKE  ScreenToClient,wParam,eax
        INVOKE  ScreenToClient,wParam,esp
        print   chr$('X=')
        pop     edi
        print   str$(edi),32
        print   chr$('Y=')
        pop     ebx
        print   str$(ebx),32
        print   chr$('W=')
        pop     eax
        sub     eax,edi
        print   str$(eax),32
        print   chr$('H=')
        pop     eax
        sub     eax,ebx
        print   str$(eax),13,10

loop01: inc     esi
        cmp     esi,0FFFFh
        jbe     loop00

        pop     ebx
        pop     esi
        pop     edi
        mov byte ptr ReportFlag,-1

CbtP02: INVOKE  CallNextHookEx,hMbHook,nCode,wParam,lParam
        ret

CBTProc ENDP

;--------------------------------------------------------------------------------------------

        END     _main

